#
# spec file for package fcitx5-chinese-addons
#
# Copyright (c) 2024 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           fcitx5-chinese-addons
Version:        5.1.3
Release:        1.3
Summary:        Pinyin and Table IM support for fcitx5
License:        GPL-2.0-or-later AND LGPL-2.1-or-later
Group:          System/I18n/Chinese
URL:            https://github.com/fcitx/fcitx5-chinese-addons
Source:         https://download.fcitx-im.org/fcitx5/%{name}/%{name}-%{version}_dict.tar.xz
BuildRequires:  cmake
BuildRequires:  extra-cmake-modules
BuildRequires:  fcitx5-devel
BuildRequires:  fcitx5-lua-devel
BuildRequires:  fcitx5-qt-devel
BuildRequires:  fdupes
BuildRequires:  fmt-devel
BuildRequires:  hicolor-icon-theme
BuildRequires:  libQt5Concurrent-devel
BuildRequires:  libQt5DBus-devel
# BuildRequires:  libQt5WebKitWidgets-devel
BuildRequires:  libboost_iostreams-devel
BuildRequires:  libboost_regex-devel
BuildRequires:  libcurl-devel
BuildRequires:  libime-devel >= 1.0.12
BuildRequires:  libqt5-qtwebengine-devel
BuildRequires:  opencc-devel
BuildRequires:  pkgconfig
BuildRequires:  xz
Supplements:    fcitx5
Conflicts:      fcitx <= 4.2.9.8
Provides:       fcitx-cloudpinyin = %{version}
Provides:       fcitx-googlepinyin = %{version}
Provides:       fcitx-libpinyin = %{version}
Provides:       fcitx-pinyin = %{version}
Provides:       fcitx-sunpinyin = %{version}
Provides:       fcitx-table = %{version}
Provides:       fcitx-table-cn-bingchan = %{version}
Provides:       fcitx-table-cn-cangjie = %{version}
Provides:       fcitx-table-cn-dianbao = %{version}
Provides:       fcitx-table-cn-erbi = %{version}
Provides:       fcitx-table-cn-wanfeng = %{version}
Provides:       fcitx-table-cn-wubi = %{version}
Provides:       fcitx-table-cn-wubi-pinyin = %{version}
Provides:       fcitx-table-cn-ziran = %{version}
Obsoletes:      fcitx-cloudpinyin <= 0.3.7
Obsoletes:      fcitx-googlepinyin <= 0.1.6
Obsoletes:      fcitx-libpinyin <= 0.5.3
Obsoletes:      fcitx-pinyin <= 4.2.9.6
Obsoletes:      fcitx-sunpinyin <= 0.4.2
Obsoletes:      fcitx-table <= 4.2.9.6
Obsoletes:      fcitx-table-cn-bingchan < 4.2.9.6
Obsoletes:      fcitx-table-cn-cangjie < 4.2.9.6
Obsoletes:      fcitx-table-cn-dianbao < 4.2.9.6
Obsoletes:      fcitx-table-cn-erbi < 4.2.9.6
Obsoletes:      fcitx-table-cn-wanfeng < 4.2.9.6
Obsoletes:      fcitx-table-cn-wubi < 4.2.9.6
Obsoletes:      fcitx-table-cn-wubi-pinyin < 4.2.9.6
Obsoletes:      fcitx-table-cn-ziran < 4.2.9.6
%if 0%{?suse_version} == 1500
BuildRequires:  gcc8
BuildRequires:  gcc8-c++
%else
BuildRequires:  gcc-c++
%endif
%if 0%{?suse_version} <= 1520
BuildRequires:  appstream-glib-devel
%endif

%description
This provides pinyin and table input method support for fcitx5.

%package -n fcitx5-pinyindictmanager
Summary:        Fcitx5 Pinyin dictionary manager library
Group:          System/Libraries
Supplements:    (fcitx5 and plasma5-workspace)

%description -n fcitx5-pinyindictmanager
Fcitx5 Pinyin dictionary manager library.

%package devel
Summary:        Development files for fcitx5-chinese-addons
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}
Requires:       fcitx5-pinyindictmanager = %{version}

%description devel
This package provides development files for fcitx5-chinese-addons.

%prep
%setup -q

%build
%if 0%{?suse_version} == 1500
export CC=gcc-8
export CXX=g++-8
%endif
%cmake -DUSE_WEBKIT=OFF
%make_build

%install
%cmake_install
%find_lang %{name}
%fdupes %{buildroot}

%files -n fcitx5-pinyindictmanager
%{_fcitx5_qt5dir}/libpinyindictmanager.so

%files -f %{name}.lang
%doc README.md
%license LICENSES
%dir %{_fcitx5_datadir}/pinyinhelper
%dir %{_fcitx5_datadir}/punctuation
%dir %{_fcitx5_datadir}/lua
%dir %{_fcitx5_datadir}/lua/imeapi
%dir %{_fcitx5_datadir}/lua/imeapi/extensions
%dir %{_fcitx5_datadir}/pinyin
%dir %{_fcitx5_datadir}/chttrans
%dir %{_fcitx5_libdir}/qt5
%{_bindir}/scel2org5
%{_fcitx5_libdir}/libchttrans.so
%{_fcitx5_libdir}/libcloudpinyin.so
%{_fcitx5_libdir}/libfullwidth.so
%{_fcitx5_libdir}/libpinyin.so
%{_fcitx5_libdir}/libpinyinhelper.so
%{_fcitx5_libdir}/libpunctuation.so
%{_fcitx5_libdir}/libtable.so
%{_fcitx5_libdir}/qt5/libcustomphraseeditor.so
%{_fcitx5_addondir}/chttrans.conf
%{_fcitx5_addondir}/cloudpinyin.conf
%{_fcitx5_addondir}/fullwidth.conf
%{_fcitx5_addondir}/pinyin.conf
%{_fcitx5_addondir}/pinyinhelper.conf
%{_fcitx5_addondir}/punctuation.conf
%{_fcitx5_addondir}/table.conf
%{_fcitx5_datadir}/chttrans/gbks2t.tab
%{_fcitx5_imconfdir}/cangjie.conf
%{_fcitx5_imconfdir}/db.conf
%{_fcitx5_imconfdir}/erbi.conf
%{_fcitx5_imconfdir}/pinyin.conf
%{_fcitx5_imconfdir}/qxm.conf
%{_fcitx5_imconfdir}/shuangpin.conf
%{_fcitx5_imconfdir}/wanfeng.conf
%{_fcitx5_imconfdir}/wbpy.conf
%{_fcitx5_imconfdir}/wbx.conf
%{_fcitx5_imconfdir}/zrm.conf
%{_fcitx5_datadir}/pinyinhelper/py_stroke.mb
%{_fcitx5_datadir}/pinyinhelper/py_table.mb
%{_fcitx5_datadir}/punctuation/punc.mb.*
%{_fcitx5_datadir}/lua/imeapi/extensions/pinyin.lua
%{_fcitx5_datadir}/pinyin/chaizi.dict
%{_fcitx5_datadir}/pinyin/emoji.dict
%{_datadir}/icons/hicolor/*/apps/org.fcitx.Fcitx5.fcitx-*
%{_datadir}/icons/hicolor/*/apps/fcitx-*
%{_datadir}/metainfo/org.fcitx.Fcitx5.Addon.ChineseAddons.metainfo.xml

%files devel
%{_includedir}/Fcitx5/Module
%{_libdir}/cmake/Fcitx5ModuleCloudPinyin
%{_libdir}/cmake/Fcitx5ModulePinyinHelper
%{_libdir}/cmake/Fcitx5ModulePunctuation

%changelog
* Mon Feb  5 2024 Marguerite Su <i@marguerite.su>
- update to 5.1.3
  * Improve pinyin initial loading by loading all the features, so first
    stroke related key press won't be slowed down.
  * Add extra dictionary support for the table engine. Right now, you
    will need to put the dict file manually under
    ~/.local/share/fcitx5/table/[tablename].dict.d/. scel2org5 have a new
    option convert the dict to acceptable txt format. For the ease of use,
    both txt/binary dict are accepted under that directory. But you will
    need to make sure, that the table has built-in phrase rule, otherwise
    it won't work.
  * Port UI plugin to qt6
  * Default to webengine since qt webkit is lack of maintenance.
- changes in 5.1.2
  * Pinyin prediction may also show words from pinyin dict, not just
  from the model.
  * Add an animation for cloudpinyin loading
  * Allow table to use other key for select default candidate other than space.
* Tue Oct  3 2023 Marguerite Su <i@marguerite.su>
- update to 5.1.1
  * Allow compose key to be used for table/pinyin
  * Fix exact matching mode for table
  * fix resolving some scel file
  * improve the case that cloud pinyin candidate position
    is the first one.
* Sat Sep 30 2023 Marguerite Su <i@marguerite.su>
- fix build on leap, gcc7 doesn't have charconv
* Sun Aug 20 2023 Marguerite Su <i@marguerite.su>
- update to 5.1.0
  * new custom phrase feature
  * new punctuation feature that allows punctuation to be shown
    as a candidate list
* Mon May 22 2023 Marguerite Su <i@marguerite.su>
- Update to 5.0.17
  * pinyin dictionary manager now have a button open the user dictionary
    directory
  * hide shuang pin option in pinyin config
  * table allow keypad key as selection key
* Sun Nov 20 2022 Fusion Future <qydwhotmail@gmail.com>
- Update to 5.0.16
  * Allow change the behavior when  switch input method for Pinyin
  * Update emoji pinyin data
  * If input is partially selected, press enter will also commit the
    selected part, instead of just raw pinyin.
- Remove obsolete patch
  * fcitx5-chinese-addons-qt-5.9.patch
* Tue Sep 20 2022 Marguerite Su <i@marguerite.su>
- update to 5.0.15
  * table: Add prediction support for table
  * pinyin: Add support for disabling a set of character in extb and beyond
- switch source to _dict variant.
- drop
  * fcitx5-chinese-addons-no-download.patch
  * py_table-20121124.tar.gz
  * py_stroke-20121124.tar.gz
* Tue Jul  5 2022 Fusion Future <qydwhotmail@gmail.com>
- Update to 5.0.14
  * moving the cursor will filter the candidates to show only text till
    the cursor in Pinyin. This allows you to easily select a prefix of the
    sentence result, instead of selecting every single word till the point
    you want to change.
  * allow you to learn phrases with other phrases in the table engine.
  * ng/gn option is renamed to common typo and includes more auto
    correction. See libime changelog for more details on this change.
- BuildRequires libime-devel >= 1.0.12 (gh#fcitx/fcitx5-chinese-addons#93)
* Sat Mar 12 2022 Marguerite Su <i@marguerite.su>
- update version 5.0.12
  * Add more icon with smaller size
  * Set component for misc files
  * Set component config for some files
  * Do not load failed to open shuangpin profile
* Sun Feb 13 2022 Marguerite Su <i@marguerite.su>
- split subpackage fcitx5-pinyindictmanager
  * GNOME users complain that there is too much usage on Qt, the
    Qt depends will be reduced a lot with this split
* Sat Jan 29 2022 Marguerite Su <i@marguerite.su>
- resolve file conflicts with fcitx
* Tue Jan 25 2022 Marguerite Su <i@marguerite.su>
- update version 5.0.10
  * Partial shuangpin support. It's a new option
* Sat Jan 15 2022 Marguerite Su <i@marguerite.su>
- fix requirements
* Wed Dec 15 2021 Marguerite Su <i@marguerite.su>
- update version 5.0.9
  * Adjust some default options
* Sat Nov  6 2021 J <hj@powersnail.com>
- update to version 5.0.8
  * Support show a marker for auto phrase
  * Fix keypad and table engine
  * Fix key event leaking for certain cases
  * Show shuangpin profile name in the information
* Wed May  5 2021 Marguerite Su <i@marguerite.su>
- update version 5.0.6
  * Fix missing dependencies in cmake
  * Relax the possible corruption file checkin
- changes in version 5.0.5
  * Add gui support for punctuation customization
  * Fix 2nd 3rd selection key detection
* Tue Mar 16 2021 Marguerite Su <i@marguerite.su>
- update version 5.0.4
  * reduce the memory by make pinyin helper
    data load on-demand
  * change the default punctuation mapping
    for * from multiple sign to *.
* Sun Jan 31 2021 Marguerite Su <i@marguerite.su>
- update version 5.0.3
  * Add fcitx4's AutoEng like functionality to pinyin, e.g. type "www."
  will enter quickphrase mode.
  * Add support for regular expression to trigger auto select in table.
  Right now this is used by Erbi for code started with u/v.
  * Add support for switching to quickphrase mode in the table engine
  for certain texts, e.g. uppercase will make Wubi enter quickphrase
  mode now.
  * Add support for deleting any word in the table engine, including
  the one in main dict.
  * Add support for proxy to cloudpinyin
  * In Pinyin, ng will now also look up for "n g", e.g. 那个
  * Fix libime_tabledict conversion for user dictionary.
* Sun Dec  6 2020 Marguerite Su <i@marguerite.su>
- update version 5.0.2
* Tue Nov 10 2020 Marguerite Su <i@marguerite.su>
- update version 5.0.1
* Fri Sep  4 2020 Marguerite Su <i@marguerite.su>
- update version 4.99.0+git20200903.9ef492e
* Wed Mar  4 2020 Xu Zhao <i@xuzhao.net>
- update to version git20200212.3dae7a2
  * Use new candidate list api
  * Update license header
  * Use standard library string_view
  * Don't toggle punctuation in irrelevant im
* Sun Sep 16 2018 i@marguerite.su
- initial package
- add fcitx5-chinese-addons-no-download.patch, OBS VM has no network
